"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const etcd_metadata_accessor_1 = require("./etcd-metadata.accessor");
const etcd_orchestrator_1 = require("./etcd.orchestrator");
let EtcdExplorer = class EtcdExplorer {
    constructor(discoveryService, metadataAccessor, etcdOrchestrator) {
        this.discoveryService = discoveryService;
        this.metadataAccessor = metadataAccessor;
        this.etcdOrchestrator = etcdOrchestrator;
    }
    async onModuleInit() {
        this.explore();
        await this.etcdOrchestrator.mountKeyValues();
    }
    explore() {
        const providers = [
            ...this.discoveryService.getProviders(),
            ...this.discoveryService.getControllers(),
        ];
        providers.forEach((wrapper) => {
            const { instance } = wrapper;
            if (!instance || typeof instance === 'string') {
                return;
            }
            this.lookupKeyValues(instance);
        });
    }
    lookupKeyValues(instance) {
        const keyValues = this.metadataAccessor.getKeyValues(instance);
        if (keyValues) {
            this.etcdOrchestrator.addKeyValue(instance, keyValues);
        }
    }
};
EtcdExplorer = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [core_1.DiscoveryService,
        etcd_metadata_accessor_1.EtcdMetadataAccessor,
        etcd_orchestrator_1.EtcdOrchestrator])
], EtcdExplorer);
exports.EtcdExplorer = EtcdExplorer;
