"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var EtcdModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestcloud2/common");
const common_2 = require("@nestjs/common");
const etcd3_1 = require("etcd3");
const core_1 = require("@nestjs/core");
const etcd_constants_1 = require("./etcd.constants");
const etcd_explorer_1 = require("./etcd.explorer");
const etcd_metadata_accessor_1 = require("./etcd-metadata.accessor");
const etcd_orchestrator_1 = require("./etcd.orchestrator");
let EtcdModule = EtcdModule_1 = class EtcdModule {
    static forRoot(options) {
        return this.register(options);
    }
    static forRootAsync(options) {
        return this.register(options);
    }
    static register(options = { hosts: '127.0.0.1:2379' }) {
        const inject = options.inject || [];
        const etcdOptionsProvider = {
            provide: etcd_constants_1.ETCD_OPTIONS_PROVIDER,
            useFactory: (...params) => {
                const registerOptions = options;
                const boot = params[inject.indexOf(common_1.BOOT)];
                if (boot) {
                    options = boot.get(this.CONFIG_PREFIX);
                }
                return Object.assign(registerOptions, options);
            },
            inject,
        };
        const etcdProvider = {
            provide: common_1.ETCD,
            useFactory: (options) => {
                this.parseCertificate(options);
                return new etcd3_1.Etcd3(options);
            },
            inject: [etcd_constants_1.ETCD_OPTIONS_PROVIDER],
        };
        return {
            module: EtcdModule_1,
            providers: [etcdOptionsProvider, etcdProvider, etcd_explorer_1.EtcdExplorer],
            exports: [etcdProvider],
        };
    }
    static parseCertificate(options) {
        if (options.credentials) {
            if (options.credentials.rootCertificate) {
                options.credentials.rootCertificate = new Buffer(options.credentials.rootCertificate);
            }
            if (options.credentials.privateKey) {
                options.credentials.privateKey = new Buffer(options.credentials.privateKey);
            }
            if (options.credentials.certChain) {
                options.credentials.certChain = new Buffer(options.credentials.certChain);
            }
        }
        return options;
    }
};
EtcdModule.CONFIG_PREFIX = 'etcd';
EtcdModule = EtcdModule_1 = __decorate([
    common_2.Global(),
    common_2.Module({
        imports: [core_1.DiscoveryModule],
        providers: [etcd_metadata_accessor_1.EtcdMetadataAccessor, etcd_orchestrator_1.EtcdOrchestrator],
    })
], EtcdModule);
exports.EtcdModule = EtcdModule;
